package it.cavallium.strangedb.server;

import it.cavallium.strangedb.database.DatabaseCore;

import java.io.IOException;
import java.nio.file.Path;

public class DatabaseSimple extends DatabaseCore {
	private final DatabaseNodesIO databaseNodesIO;

	public DatabaseSimple(Path dataFile, Path blocksMetaFile, Path referencesMetaFile) throws IOException {
		super(dataFile, blocksMetaFile, referencesMetaFile);
		this.databaseNodesIO = new DatabaseNodesIO(referencesIO, referencesMetadata);
	}

	public String get(CharSequence path) throws IOException {
		return databaseNodesIO.get(path);
	}

	public void set(CharSequence path, String value) throws IOException {
		databaseNodesIO.set(path, value);
	}

	public boolean exists(CharSequence path) throws IOException {
		return databaseNodesIO.exists(path);
	}

	public int size(CharSequence path) throws IOException {
		return databaseNodesIO.size(path);
	}
}
