package it.cavallium.strangedb.server;

import java.util.Arrays;

public class ValueNode implements Node {

	private final long reference;
	private final ValueType valueType;
	private long value;

	public ValueNode(long reference, long value, ValueType valueType) {
		this.reference = reference;
		this.value = value;
		this.valueType = valueType;
	}

	public long getValueReference() {
		return value;
	}

	public void setValue(long value) {
		this.value = value;
	}

	@Override
	public NodeType getType() {
		return NodeType.VALUE;
	}

	public ValueType getValueType() {
		return valueType;
	}

	@Override
	public long getReference() {
		return reference;
	}

	@Override
	public Node copy() {
		return new ValueNode(reference, value, valueType);
	}
}
